unit DFMX1;

{ DFM extractor (C)2K, By Paul TOTH <tothpaul@free.fr>
  http://tothpaul.free.fr

 the purpose of this program is to recover lost DFM from a compiled EXE.
 save the resource with the same name as your Unit.
}
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl,
  ExeImage,RxTypes { From Delphi Resxplor Demo };

type
  TForm1 = class(TForm)
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Quit: TButton;
    Extract: TButton;
    ListBox1: TListBox;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    procedure FileListBox1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure ExtractClick(Sender: TObject);
  private
    { Dclarations prives }
    e:TExeImage;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FileListBox1Change(Sender: TObject);

 procedure Browse(List:TResourceList);
  var
   i:integer;
   r:TResourceItem;
  begin
   for i:=0 to List.Count-1 do begin
    r:=List[i];
    if r.IsList then
     Browse(r.List)
    else begin
     if (r.ResType=rtRcData)and(longint(r.RawData^)=$30465054) { "TPF0" } then begin
      Listbox1.Items.AddObject(r.Name,r);
     end;
    end;
   end;
  end;

begin
 e.free; e:=nil;
 if FileListBox1.FileName='' then exit;
 e:=TExeImage.Create(Self,FileListBox1.FileName);
 ListBox1.Items.Clear;
 Browse(e.Resources);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 e.free;
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.ExtractClick(Sender: TObject);
var
 i,k:integer;
 n:string;
 r:TResourceItem;
 s:TFileStream;
begin
 i:=ListBox1.ItemIndex;
 if i<0 then exit;
 n:=ListBox1.Items[i];
 SaveDialog1.FileName:=copy(n,2,length(n))+'.dfm';
 if SaveDialog1.Execute then begin
  s:=TFileStream.Create(SaveDialog1.FileNAme,fmOpenWrite or fmCreate);
  r:=TResourceItem(ListBox1.Items.Objects[i]);
  k:=$000AFF; s.WriteBuffer(k,3);   // header (?)
  s.WriteBuffer(n[1],Length(n));    // add Resource name
  k:=$103000; s.WriteBuffer(k,3);   // ?
  k:=r.Size; s.WriteBuffer(k,4);    // add resource size
  s.WriteBuffer(r.RawData^,r.Size); // save resource
  s.Free;
 end;
end;

end.
